sub report_availability {
  my ( $report_status_as, $notes ) = @_;

  if ( ! defined AVAILABILITY_URL and
       ! defined AVAILABILITY_USERNAME and
       ! defined AVAILABILITY_PASSWORD and
       ! defined AVAILABILITY_OPTIONAL_CURL_PARAMS and
       ! defined AVAILABILITY_USE_POST_NOT_GET
     ) {
     print "availability_lib.pl: ERROR: some required variable not defined.";
     return 0;
  }

  chomp ( my $computer_name = `/bin/hostname -s` );
  my $curl_command = "/usr/bin/curl $AVAILABILITY_OPTIONAL_CURL_PARAMS";
  my $base_form_url = "machine=$computer_name&type=mac";
  if ( $AVAILABILITY_USERNAME ne "" and $AVAILABILITY_PASSWORD ne "" ) {
    if ( $AVAILABILITY_URL =~ /^https/ ) {
      $base_form_url .= "&username=$AVAILABILITY_USERNAME&password=$AVAILABILITY_PASSWORD";
    } else {
      $curl_command .= " -u $AVAILABILITY_USERNAME:$AVAILABILITY_PASSWORD";
    }
  }
  if ( $report_status_as eq "available") {
    $form_url = $base_form_url . "&login=logged_out&oo=NULL&notes=$notes";
  } elsif ( $report_status_as eq "unavailable_login") {
    $form_url = $base_form_url . "&login=logged_in&oo=NULL&notes=$notes";
  } elsif ( $report_status_as eq "unavailable_maintenance") {
    $form_url = $base_form_url . "&login=logged_out&oo=oo&notes=$notes";
  }
  if ( $AVAILABILITY_USE_POST_NOT_GET ) {
    system "$curl_command -d \"$form_url\" $AVAILABILITY_URL &> /tmp/labstatus_log &";
  } else {
    system "$curl_command \"$AVAILABILITY_URL?$form_url\" &> /tmp/labstatus_log &";
  }
  system "/usr/sbin/chown root:wheel /tmp/labstatus_log";
  system "/bin/chmod 770 /tmp/labstatus_log";
  system "/bin/date >> /tmp/labstatus_log";
  return 1;
}

1;
