#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/etc/entman/conf/";
require "entman_config.pl";
require "configure/shadow_classic.pl";


################################################################################
#
# Creates shadow classic startup
#
################################################################################

$classicstartuploc="/System/Library/CoreServices/Classic Startup.app/Contents/MacOS/Classic Startup";

$classicstartuprealloc="/System/Library/CoreServices/Classic Startup.app/Contents/MacOS/Real Classic Startup";

if ( -e $classicstartuprealloc ) {

  entman_logger ( "log drawer", "Classic Startup Real already exists." );

} else {

  system "/bin/mv \"$classicstartuploc\" \"$classicstartuprealloc\"";
  
  open ( FILEHANDLE, ">$classicstartuploc" );

  print FILEHANDLE << "EOF";
#!/bin/sh

if [ -e "$shadow_classic_dmg" -a ! -d "$shadow_classic_mount" ]; then
	/usr/bin/hdid "$shadow_classic_dmg" -shadow ~/Library/Preferences/ClassicShadow
fi
"$classicstartuprealloc"
EOF
  close ( FILEHANDLE );

  system "/bin/chmod +x \"$classicstartuploc\"";

}

entman_logger ( "log drawer", "Created Shadow Classic Startup." );

exit 0;
