#!/usr/bin/perl

################################################################################
# Copyright (c) 2008 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

$system_log_watch_messages = "/Library/Preferences/Xhooks/secure/system_log_watch";
$system_log_ignore_messages = "/Library/Preferences/Xhooks/secure/system_log_ignore";
$system_log_alert_messages = "/Library/Preferences/Xhooks/secure/system_log_alert";

################################################################################
# Run periodic scripts
#
if ( defined $AUTO_LONG_MAINTENANCE_HOURS ) {
  if ( $AUTO_LONG_MAINTENANCE_HOURS =~ /(\d+) (\d+)/ ) {
    if ( timewindow( $1, $2 ) ) {

	  entman_logger ( "log drawer", "Running periodic scripts." );

	  check_log();

      my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime time;

      if ( -M "/var/log/daily.out" > 1 ) {
        system "/usr/sbin/periodic daily";
      }

      if ( $mday == 1 or -M "/var/log/weekly.out" > 7 ) {
        system "/usr/sbin/periodic weekly";
      }

      if ( $wday == 6 or -M "/var/log/monthly.out" > 31 ) {
        system "/usr/sbin/periodic monthly";
      }

	  entman_logger ( "log drawer", "Periodic scripts done." );

    }
  }
}

sub check_log {
  if ( -e $system_log_watch_messages and -e $system_log_ignore_messages ) {

    # Check log file
    system "/usr/bin/grep -i -f \"$system_log_watch_messages\" /var/log/system.log | /usr/bin/grep -v -f \"$system_log_ignore_messages\" > \"$system_log_alert_messages\"";

    if ( -e $system_log_alert_messages ) {
      # Email results
      wait_for_network();
      $HOSTNAME=`/bin/hostname`;
      $DATE=`/bin/date +%m/%d/%y:%H.%M`;
      system "/bin/cat \"$system_log_alert_messages\" | /usr/bin/mail -s \"System.log report for $HOSTNAME $DATE \" root";

    }
  }
}

exit 0;
