#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

$postm_prebinding_done_trigger = "/Library/Preferences/Xhooks/postm_prebinding_done";

if ( ! -e $postm_prebinding_done_trigger and defined $AUTO_LONG_MAINTENANCE_HOURS ) {
  if ( $AUTO_LONG_MAINTENANCE_HOURS =~ /(\d+) (\d+)/ ) {
    if ( timewindow( $1, $2 ) ) {

      entman_logger ( "log drawer", "Updating prebinding." );

      system "/usr/bin/update_prebinding -root / -force";
      system "/usr/bin/touch \"$postm_prebinding_done_trigger\"";

      entman_logger ( "log drawer", "Prebinding updated." );

    }
  }
}


exit 0;
