#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

$updateByHostPrefs_script = "/Library/Xhooks/Modules/edu.utah.scl.home_folder/updateByHostPrefs.sh";

################################################################################
# Fix the ByHost folder

if ( ! defined $ARGV[0] ) {
  entman_logger ( "log drawer", "No username specified!" );
  exit 1;
}

$homefolder = ( getpwnam( $ARGV[0] ) ) [7];

updateByHost( $homefolder );

entman_logger ( "log drawer", "ByHost preferences fixed." );

sub updateByHost {
  # This subroutine is to handle spaces in folder names (which updateByHostPrefs script doesn't do)
  my ( $folder ) = @_;
  
  if ( ! -d $folder ) {
    entman_logger ( "log drawer", "The folder $folder does not exist." );
    return;
  }
  
  if ( -e "/tmp/ByHost" ) {
    system "/usr/bin/chflags", "-R", "nouchg", "/tmp/ByHost";
    system "/bin/rm", "-rf", "/tmp/ByHost";
  }

  system "/bin/mv", $folder, "/tmp/ByHost";

  system $updateByHostPrefs_script, "/tmp/ByHost";

  system "/bin/mv", "/tmp/ByHost", $folder;

}

exit 0;
