#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

entman_logger ( "log drawer", "Making /Users/Shared symlink." );

if ( ! defined $ARGV[0] ) {
  entman_logger ( "log drawer", "No username specified!" );
  exit 1;
}

my $theuser = $ARGV[0];

my $system_homefolder = ( getpwnam( $theuser ) ) [7];
my $gid = getgrnam($theuser);
my $uid = getpwnam($theuser);

$shared_link = "/Users/Shared";
$shared_real = "$system_homefolder/Shared";

if ( -l $shared_link ) {
  #print "removing link $shared_link\n";
  unlink $shared_link;
}
if ( ! -e $shared_link ) {
  #print "making link $shared_link\n";
  symlink $shared_real, $shared_link;
  if ( ! -e $shared_real ) {
    #print "making dir $shared_real\n";
    mkdir $shared_real;
    chown $uid, $gid, $shared_real;
    chmod 0777, $shared_real;
  }
}
