#!/usr/bin/ruby

require "etc"
require "fileutils"

radmind_ignores = "/Volumes/Radmind Ignores"

links=[
  "Documents/Eudora Folder",
  "Library/Mail",
  "Music/iTunes",
  "Shared/SC Info",
  "Library/Widgets",
  "Library/PreferencePanes",
]


if( ARGV[0] == nil )
  puts "Please provide a user name."
  exit 1
end

begin
  user = Etc.getpwnam( ARGV[0] )
rescue StandardError => err
  puts "Script failed: " + err
  exit 1
end

if( user.name == "mac" )
  exit 0
end

saved_prefs_home = radmind_ignores + "/." + user.name
saved_links_home = radmind_ignores + "/" + user.name

puts user.name
puts saved_prefs_home
puts saved_links_home  

if( File.exist?( user.dir ) and File.directory?( user.dir ) )
  puts "Dittoing #{saved_prefs_home} to  #{user.dir}"
	system '/usr/bin/ditto', saved_prefs_home, user.dir
else
	puts "Prefs have not yet been saved."
end

links.each do |current_link|
  link_to_location = saved_links_home + "/" + current_link
  orig_dir_location = user.dir + "/" + current_link
  if( File.exists?( link_to_location ) and File.directory?( link_to_location ) )
    if( File.exists?( orig_dir_location ) and File.symlink?( orig_dir_location ) )
      FileUtils.rm( orig_dir_location )
      puts "Changing symlink #{orig_dir_location} to point to #{link_to_location}"
      FileUtils.ln_s( link_to_location, orig_dir_location )
    elsif( File.exists?( orig_dir_location ) and File.directory?( orig_dir_location) )
      if( File.exists?( orig_dir_location + ".orig" ) )
        FileUtils.rm_r( orig_dir_location + ".orig" )
      end
      FileUtils.mv( orig_dir_location, orig_dir_location + ".orig" )
      puts "Creating symlink #{orig_dir_location} pointing to #{link_to_location}"
      FileUtils.ln_s( link_to_location, orig_dir_location )
    end
  end
end

exit 0
