#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

################################################################################
# entman - modules
#
# killsumapps.pl
#
# This script kills apps for the user currently logged in.  There is an
# exclusion list so that it doens't quit apps you want running.  This script
# needs to know the username.  You can either pass it in as the first parameter,
# or if there is a user logged in, this script will get it.  If the Mac is logged
# out and nothing is passed in, this script will exit.
#
################################################################################

if ( ! defined $ARGV[0] ) {
  entman_logger ( "log drawer", "No username specified!" );
  exit 1;
}

$theuser = $ARGV[0];

#############################################
# These apps will not be quit.  Use the full path.
# To get a list of all apps on your box, type in Terminal "ps -axo user,command"
# To get a list of only certain user apps, type "ps -xo user,command -U username"
# This list is current for 10.2.1  (10.1.x uses a different path for loginwindow)

# Jaguar list:
#@allowedApps =
#  ("/System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ATS.framework/Versions/A/Support/ATSServer",
#   "/System/Library/CoreServices/WindowServer",
#   "/System/Library/CoreServices/loginwindow.app/Contents/MacOS/loginwindow",
#   "/System/Library/CoreServices/pbs",
#   "/System/Library/CoreServices/SecurityAgent.app/Contents/MacOS/SecurityAgent", 
#   "/System/Library/Frameworks/ScreenSaver.framework/Versions/A/Resources/ScreenSaverEngine.app/Contents/MacOS/ScreenSaverEngine", 
#   "/Library/PreferencePanes/FruitMenu.prefPane/Contents/MacOS/FruitMenu");

  #   "/System/Library/CoreServices/SystemUIServer.app/Contents/MacOS/SystemUIServer",  kill this so that the menu is updated.

# Panther list:
@allowedApps = (
                "/System/Library/Frameworks/ApplicationServices.framework/Frameworks/ATS.framework/Support/ATSServer",
                "/System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/Metadata.framework/Versions/A/Support/mdimportserver",
                "/System/Library/Frameworks/ScreenSaver.framework/Resources/ScreenSaverEngine.app/Contents/MacOS/ScreenSaverEngine",
                "/System/Library/CoreServices/loginwindow.app/Contents/MacOS/loginwindow console",
                "/Library/KeyAccess/KeyAccess.app/Contents/SharedSupport/kass.app/Contents/MacOS/kass",
                "/System/Library/CoreServices/RemoteManagement/ARDAgent.app/Contents/MacOS/ARDAgent",
                "/System/Library/CoreServices/RemoteManagement/AppleVNCServer.bundle/Contents/MacOS/AppleVNCServer",
                "/System/Library/CoreServices/pbs",
                "/System/Library/CoreServices/SystemUIServer.app/Contents/MacOS/SystemUIServer",
                "aped",
                "/Library/Xhooks/Utilities/Helpers/EntmanMenu.app/Contents/MacOS/EntmanMenu",
               );

################################################################################
# Internal stuff
#

# Log this
entman_logger ( "log", "Running." );

########################################################################
# Lets kill sum apps!
########################################################################

####################################
# Get all the applications running right now.
@runningApps = getAppsRunningRightNow( $theuser );
# Loop through runningApp and remove allowedApps
@killMe = ();
$repeat1 = @runningApps;
$repeat2 = @allowedApps;
for ( $i = 0; $i < $repeat1; $i++ ) {
  $iDie = 1;
  for ( $j = 0; $j < $repeat2; $j++ ) {
    #Another way to do the next line (results -1 or 6): rindex ($runningApps[$i],$allowedApps[$j],6)
    if( grep( /$allowedApps[$j]/, $runningApps[$i] ) ) {
      $iDie = 0;
    }
  }
  if ( $iDie ) {
    push( @killMe, $runningApps[$i] );
  }
}

#print "@killMe\n\n";

# Loop through the list of apps to kill and get the pid
@iWillDie = ();
for $i ( @killMe ) {
  $_ = substr( $i, 0, 6 );
  $bla = /\s*(\d+)\s*/;
  push ( @iWillDie, $1 );
}
# Kill the apps!
for $i ( @iWillDie ) {
  #print "kill $i\n";
  system "kill $i";
}

exit 0;

################################################################################
sub getAppsRunningRightNow {
  local ( $username ) = @_;
  open ( PROC, "ps -wwxo pid,command -U $username | grep -v 'PID COMMAND' |" );
  @proclist = <PROC>;
  close PROC;
  chomp( @proclist);
  return @proclist;
}
