#!/usr/bin/perl

################################################################################
# Copyright (c) 2007 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

$watch_folder = "/private";
$temp_script = "$watch_folder/temp_script.pl";
$launch_maintenance_now = "$watch_folder/radmind";
$launch_maintenance_now_balanced = "$watch_folder/radmind_balanced";
$run_prepForOverload = "$watch_folder/prep";
$prepForOverload_script = "/usr/local/bin/prep_for_overload";

my $run_maintenance_startup_trigger = "/Library/Preferences/Xhooks/triggerfiles/run_maintenance";

# Launch tmp script if it exists
if ( -e $temp_script ) {
  say( "Launching temp script" );
  system "/bin/chmod 755 \"$temp_script\"";
  system $temp_script;
  system "/bin/rm -rf \"$temp_script\"";
}

# Launch maintenance
if ( -e $launch_maintenance_now ) {
  say( "Launching maintenance" );
  unlink $launch_maintenance_now;
  $run_maintenance = 1;
}

if ( -e $launch_maintenance_now_balanced ) {
  say( "Launching maintenance shadowed" );
  unlink $launch_maintenance_now_balanced;
  system "/usr/bin/touch \"$use_shadow_server\"";
  $run_maintenance = 1;
}

if ( $run_maintenance ) {
  system "/usr/bin/touch $run_maintenance_startup_trigger";
  warn_users_of_restart() if $idlescript_warn_user_of_reboot_switch;
  entman_logger ( "log", "Rebooting." );
  system "/sbin/reboot";
  while ( 1 ) { sleep 1 };
}

# Run prepForOverload
if ( -e $run_prepForOverload ) {
  say( "Running prepForOverload" );
  system "\"$prepForOverload_script\""; # definitely don't return
  system "/bin/rm -rf \"$run_prepForOverload\"";
}

exit 0;
