#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

# Checks to see if the user logging in is allowed.  Shows a message and kills
# loginwindow if not.  Set not allowed names in @login_invalid_logins_regexp
# in entman_global_config.pl.

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

$login_invalid_name_message_script = "/Library/Xhooks/Modules/edu.utah.scl.login/login_denied.sh";

@login_invalid_logins_regexp = ( "teacher" );

if ( ! -e "$attributes_folder/guest_logins_allowed" ) {
  push @login_invalid_logins_regexp, "^gp\\d{6}\$";
}

if ( ! defined $ARGV[0] ) {
  entman_logger ( "log drawer", "No username specified!" );
  exit 1;
}

$theuser = $ARGV[0];

################################################################################
# Check to see if login is allowed
if ( $#login_invalid_logins_regexp >= 0 ) {
  foreach $name ( @login_invalid_logins_regexp ) {
    if ( $name ne "" and grep /$name/, $theuser ) {
      system "\"$pathToiHook\" --no-titlebar --script=\"$login_invalid_name_message_script\"";
      system "/usr/bin/killall loginwindow";
    }
  }
}
