#!/bin/sh

#################################################################################
# report_to_master.sh
#
# This script contacts a web database using curl.
#
# Copyright (c) 2008 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
#
# 2005.01.10 - Version 2.  Updated it to report more info, and it now uses a
#              seperate config file
#
################################################################################

my_config="/Library/Preferences/Xhooks/edu.utah.scl.radmind_xhooks_conf.bash"

if [ -f "${my_config}" ]; then
	. "${my_config}"
	
	if [ "${REPORT_SWITCH}" = "True" ]; then
		timey=`date | awk ' { print $4 } '`
		datey=`date +%m/%d/%Y`
		my_ip=`/sbin/ifconfig en0 | grep "inet " | cut -f2 -d' '`
		my_dns=`/bin/hostname`
		my_mac_add=`/sbin/ifconfig en0 | grep ether | cut -d" " -f2 | sed s/://g`
		my_serial_num=`/usr/sbin/system_profiler -detailLevel -2 | /usr/bin/grep "Serial Number" | cut -f9 -d" "`
		if [ "$my_dns" = "" ]; then
			my_dns="unknown"
		fi
		if [ "$my_ip" = "" ]; then
			my_ip="unknown"
		fi
		if [ "$my_mac_add" = "" ]; then
			my_mac_add="unknown"
		fi
		if [ "$my_serial_num" = "" ]; then
			my_serial_num="unknown"
		fi
		save_location="/dev/null"
		client_ident="client_mac_add=${my_mac_add}&client_dns=${my_dns}&client_ip=${my_ip}&client_serial_num=${my_serial_num}"
		client_time="client_time=${timey}&client_date=${datey}"
		message_stuff="client_status=$1&client_message=$2&client_message_is_for_ip=$3&client_message_is_for_dns=$4"
		form_url="${client_ident}&${client_time}&${message_stuff}"
		/usr/bin/curl -u ${REPORT_USERNAME}:${REPORT_PASSWORD} -d "${form_url}" ${REPORT_SERVER_URL} &> ${save_location}
	fi
#else
	# email it to root?
fi
