#!/usr/bin/perl

################################################################################
# Copyright (c) 2006 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules";

use Foundation;
require "xhooks/lib/perlplist.pl";

my $debug = 0;
my $networkPrefs = $ARGV[0]."/Library/Preferences/SystemConfiguration/preferences.plist";
my $dict;
if ( -e $networkPrefs ) {
  $dict = loadDefaults( $networkPrefs );
} else {
  die "The file: $networkPrefs not found";
}

my $currentSet = perlValue(getPlistObject($dict, "CurrentSet"));
$currentSet =~ s/\/Sets\///;
print "currentSet $currentSet\n" if $debug;

@serviceOrder = perlArrayFromNSArray(getPlistObject($dict, "Sets", $currentSet, "Network", "Global", "IPv4", "ServiceOrder"));

my $ip;

foreach $ii ( @serviceOrder ) {
	my $serviceKey = perlValue($ii);
	print "serviceKey $serviceKey\n" if $debug;
	my $configMethod = perlValue(getPlistObject($dict, "NetworkServices", $serviceKey, "IPv4", "ConfigMethod"));
	print "configMethod $configMethod\n" if $debug;

#	my $active = perlValue(getPlistObject($dict, "NetworkServices", $serviceKey, "__INACTIVE__"));


	if ( $configMethod eq "Manual" ) {
		$ip = perlValue(getPlistObject($dict, "NetworkServices", $serviceKey, "IPv4", "Addresses", 0));
		last;
	}
}

print "$ip\n";
exit 0;
