#!/bin/sh
#
# Keeps a backup of command files
#
PATH=/bin:/usr/bin:/sbin:/usr/sbin:/usr/local/bin
bak=/var/radmind/backup/command
command=/var/radmind

if [ "$bak" = "" ]; then
        echo "Please configure this script with a backup location ($0)"
        exit
fi
if [ ! -e "$command" ]; then
        echo "No $command directory."
        exit
fi
if [ ! -e "$bak" ]; then
        echo "Creating $bak."
        mkdir -p "$bak"
fi

echo "Backuping up command files in $command"

cd "$bak"
i=command

if [ -x /usr/bin/tar ]; then tgzext=".tgz"; else tgzext=""; fi
if [ -f "${i}.6${tgzext}" ]; then mv -f "${i}.6${tgzext}" "${i}.7${tgzext}"; fi
if [ -f "${i}.5${tgzext}" ]; then mv -f "${i}.5${tgzext}" "${i}.6${tgzext}"; fi
if [ -f "${i}.4${tgzext}" ]; then mv -f "${i}.4${tgzext}" "${i}.5${tgzext}"; fi
if [ -f "${i}.3${tgzext}" ]; then mv -f "${i}.3${tgzext}" "${i}.4${tgzext}"; fi
if [ -f "${i}.2${tgzext}" ]; then mv -f "${i}.2${tgzext}" "${i}.3${tgzext}"; fi
if [ -f "${i}.1${tgzext}" ]; then mv -f "${i}.1${tgzext}" "${i}.2${tgzext}"; fi
if [ -f "${i}.0${tgzext}" ]; then mv -f "${i}.0${tgzext}" "${i}.1${tgzext}"; fi

cd "$command"

if [ -d "${i}" ]; then
        if [ -x /usr/bin/gzip ]; then
                tar cfvz "${i}.0${tgzext}" "${i}" && mv -f "${i}.0${tgzext}" "$bak"
        fi
fi
