/* LogoutControler.m */

/*
 Copyright (c) 2003 University of Utah Student Computing Labs.
 All Rights Reserved.

 Permission to use, copy, modify, and distribute this software and
 its documentation for any purpose and without fee is hereby granted,
 provided that the above copyright notice appears in all copies and
 that both that copyright notice and this permission notice appear
 in supporting documentation, and that the name of The University
 of Utah not be used in advertising or publicity pertaining to
 distribution of the software without specific, written prior
 permission. This software is supplied as is without expressed or
 implied warranties of any kind.
*/

#import "LogoutControler.h"
#import <fcntl.h>
#import <sys/stat.h>
#import <unistd.h>

#define TIMEOUT 30
#define LOGOUT_TRIGGER_FILE "/tmp/logoutNow"

@implementation LogoutControler

int timeout = TIMEOUT;
int counter;
BOOL loggingout = FALSE;

- (IBAction)cancel:(id)sender
{
    [NSApp terminate:self];
}

- (IBAction)logout:(id)sender
{

	[logoutButton setEnabled:NO];
	[cancelButton setEnabled:NO];
    [timerField setStringValue:[NSString stringWithFormat:@"Now logging out", counter]];
	loggingout = TRUE;

}

-(void)update
{
	if (loggingout) {

		NSURL *scriptURL = [NSURL fileURLWithPath:[[NSBundle mainBundle] pathForResource:@"logout" ofType:@"scpt"]];
		NSAppleScript *theScript = [[NSAppleScript alloc] initWithContentsOfURL:scriptURL error:nil];

		close(open(LOGOUT_TRIGGER_FILE, O_WRONLY | O_CREAT | O_EXCL, S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP | S_IROTH | S_IWOTH ));

		[theScript executeAndReturnError:nil];
		[theScript release];

	} else {

		counter--;
		[timerField setStringValue:[NSString stringWithFormat:@"Auto logout in %d seconds", counter]];
		if (counter == 0 ) {
			[self performSelector:@selector(logout:) withObject:nil afterDelay:0.0];
		}
	    [NSTimer scheduledTimerWithTimeInterval:1 target:self selector:@selector(update) userInfo:nil repeats:NO];

	}
}

-(void)awakeFromNib
{
    [mainWindow setLevel:((NSScreenSaverWindowLevel - 1))];
    [mainWindow center];
    [mainWindow makeKeyAndOrderFront:nil];
    counter = timeout;
    [timerField setStringValue:[NSString stringWithFormat:@"Auto logout in %d seconds", counter]];
    [NSTimer scheduledTimerWithTimeInterval:1 target:self selector:@selector(update) userInfo:nil repeats:NO];
}


@end
